import unittest

import os, sys
sys.path.append(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))
from  tugbot import cat_def_parser

import category_texts



class Test_cat_def_parser(unittest.TestCase):
    #def setUp(self):
        #cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_sphere)

    def test_get_field(self):
        cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_sphere)
        self.assertEqual( cat_definition.get_field("image"), "Armiliary sphere-MnM 9 NA 70-IMG 5996.JPG")
        self.assertEqual( cat_definition.get_field("artist"), "{{anonymous|author}}")
        self.assertIsNone( cat_definition.get_field("foobar") )
        self.assertIsNone( cat_definition.get_field("wood") )
        
    def test_image(self):
        cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_sphere)
        self.assertEqual( cat_definition.image, "Armiliary sphere-MnM 9 NA 70-IMG 5996.JPG")
        
    def test_type(self):
        cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_sphere)
        self.assertEqual( cat_definition.type, "Armillary sphere")
        
    def test_type_q_number(self):
        cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_sphere)
        self.assertEqual( cat_definition.type_q_number, "Q328720")   # "Armillary sphere"
        cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_Achille)
        self.assertEqual( cat_definition.type_q_number, "Q1457747")  # "Ship model"
        
    def test_get_free_text_data(self):
        cat_definition = cat_def_parser.Cat_def_parser(category_texts.commons_text_sphere)
        result_dict = {'fr': "[[:fr:Sphère armillaire|Sphère armillaire]]", 'en': '[[:en:Armillary sphere|Armillary sphere]]'}
        self.assertEqual( cat_definition.get_free_text_data("title"), result_dict)
        
    def test_get_case_variations(self):
        self.assertEqual( cat_def_parser.get_case_variations("title"), [])
        self.assertEqual( cat_def_parser.get_case_variations("musée national de la marine"), [])
        #self.assertEqual( cat_def_parser.get_case_variations("musée national de"), [])
        #self.assertEqual( cat_def_parser.get_case_variations("musée"), [])
        
if __name__ == '__main__':
    unittest.main()
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
