import unittest
from tugbot import dimensions_parser

#----------------
class Test_complex_date_parser(unittest.TestCase):
    def test_get_data(self):
        dims = dimensions_parser.Dimensions_parser("{{Size|unit=m|height=10|width=20}}")
        self.assertEqual( dims.get_data(), {'height': '10', 'width': '20', 'length_unit': 'm'})
        self.assertEqual( dims.height,     '10' )
        self.assertEqual( dims.width,     '20'  )
        self.assertEqual( dims.length_unit, 'm' )
        self.assertIsNone( dims.mass_unit       )
        
        
        dims = dimensions_parser.Dimensions_parser("{{Size|unit=mi|width=10|height=20|depth=30}}")
        self.assertEqual( dims.get_data(), {'height': '20', 'width': '10', 'depth':'30', 'length_unit': 'mi'})
        
        dims = dimensions_parser.Dimensions_parser("{{Size|cm|12.1234|98.1234|prec=1}}")
        self.assertEqual( dims.get_data(), {'length': '98.1234', 'width': '12.1234', 'length_unit': 'cm', 'prec': '1'})    
        
        dims = dimensions_parser.Dimensions_parser("{{Size|in|12.12|98.12|lang=fr}}")
        self.assertEqual( dims.get_data(), {'length': '98.12', 'width': '12.12', 'length_unit': 'in', 'lang': 'fr'})    
        
        dims = dimensions_parser.Dimensions_parser("{{Size|cm|123}}")
        self.assertEqual( dims.get_data(), {'length': '123', 'length_unit': 'cm'})           
        
        dims = dimensions_parser.Dimensions_parser("{{Size|in|123|456}}")
        self.assertEqual( dims.get_data(), {'length': '456', 'width': '123', 'length_unit': 'in'})           
        
        dims = dimensions_parser.Dimensions_parser("{{Size|ft|123|456|789}}")
        self.assertEqual( dims.get_data(), {'length': '789', 'width': '456', 'thickness': '123', 'length_unit': 'ft'}) 
        #............
        dims = dimensions_parser.Dimensions_parser("{{Size|unit=kg|mass=10}}")
        self.assertEqual( dims.get_data(), {'mass': '10', 'mass_unit': 'kg'})        
            
        dims = dimensions_parser.Dimensions_parser("{{Size|unit=g|weight=10}}")
        self.assertEqual( dims.get_data(), {'mass': '10', 'mass_unit': 'g'})  
        
        dims = dimensions_parser.Dimensions_parser("{{Size|lb|10}}")
        self.assertEqual( dims.get_data(), {'mass': '10', 'mass_unit': 'lb'})              
            
        

    
    
