import unittest

import os, sys
sys.path.append(os.path.dirname(os.path.dirname(os.path.abspath(__file__))))
from  tugbot import free_text_parser
#from  tugbot import *

import category_texts

text_langswitch = """
{{Langswitch
                      |fr=Départ d'un hydravion à Dunkerque, 13 novembre 1916
                      |en=Flying boat departing Dunkirk, 13 November 1916
                    }}"""

text_language_tags = """
{{en|this is English}}
{{fr|texte en français}}
{{de|Text auf Deutsch}}
"""

text_language_tags2 = """
{{en}} this is English
{{fr}} texte en français
{{de}} Text auf Deutsch
"""


class Test_free_text_parser(unittest.TestCase):
    def test_get_text(self):
        text_fields = free_text_parser.Free_text_parser(text_langswitch)
        self.assertEqual( text_fields.get_text("fr"), "Départ d'un hydravion à Dunkerque, 13 novembre 1916" )
        self.assertEqual( text_fields.get_text("en"), "Flying boat departing Dunkirk, 13 November 1916" )
        text_fields = free_text_parser.Free_text_parser(text_language_tags)
        self.assertEqual( text_fields.get_text("fr"), "texte en français" )
        self.assertEqual( text_fields.get_text("en"), "this is English" )
        self.assertEqual( text_fields.get_text("de"), "Text auf Deutsch" )
    
    def test_languages(self):
        text_fields = free_text_parser.Free_text_parser(text_langswitch)
        self.assertEqual( text_fields.languages, ["en", "fr"] )
        text_fields = free_text_parser.Free_text_parser(text_language_tags)
        self.assertEqual( text_fields.languages, ["de", "en", "fr"] )
 
        
if __name__ == '__main__':
    unittest.main()
    
    
    
    
