import unittest
from tugbot import medium_parser

#----------------
class Test_medium_parser(unittest.TestCase):
    def test_get_data(self):
        #{{Technique|fresco}} → fresco
        medium = medium_parser.Medium_parser("{{Technique|fresco}}")
        self.assertEqual( medium.get_data(), {'medium0': 'fresco'})
        #{{Technique|oil|canvas}} → oil on canvas
        medium = medium_parser.Medium_parser("{{Technique|oil|canvas}}")
        self.assertEqual( medium.get_data(), {'medium0': 'oil', 'medium1': 'canvas'})
        #{{Technique|oil|oak panel}} → oil on oak panel
        medium = medium_parser.Medium_parser("{{Technique|oil|oak panel}}")
        self.assertEqual( medium.get_data(), {'medium0': 'oil', 'medium1': 'oak panel'})
        #{{Technique|fresco|canvas}} → fresco on canvas
        medium = medium_parser.Medium_parser("{{Technique|fresco|canvas}}")
        self.assertEqual( medium.get_data(), {'medium0': 'fresco', 'medium1': 'canvas'})
        #{{Technique|oil|and=tempera|canvas}} → oil and tempera on canvas
        medium = medium_parser.Medium_parser("{{Technique|oil|and=tempera|canvas}}")
        self.assertEqual( medium.get_data(), {'medium0': 'oil', 'and': 'tempera', 'medium1': 'canvas'})
        #{{Technique|watercolor|over=graphite|paper}} → watercolor over graphite on paper
        medium = medium_parser.Medium_parser("{{Technique|watercolor|over=graphite|paper}}")
        self.assertEqual( medium.get_data(), {'medium0': 'watercolor', 'over': 'graphite', 'medium1': 'paper'})
        #{{Technique|drawing|paper|coloron=grey}} → drawing on gray paper
        medium = medium_parser.Medium_parser("{{Technique|drawing|paper|coloron=grey}}")
        self.assertEqual( medium.get_data(), {'medium0': 'drawing', 'coloron': 'grey', 'medium1': 'paper'})        
        #{{Technique|oil|canvas|mounted=mahogany}} → oil on canvas mounted on mahogany wood
        medium = medium_parser.Medium_parser("{{Technique|oil|canvas|mounted=mahogany}}")
        self.assertEqual( medium.get_data(), {'medium0': 'oil', 'mounted': 'mahogany', 'medium1': 'canvas'})          
        #{{Technique|indian ink|vellum|and=gold|over=pencil drawing|color=light|coloron=white}}
        medium = medium_parser.Medium_parser("{{Technique|indian ink|vellum|and=gold|over=pencil drawing|color=light|coloron=white}}")
        self.assertEqual( medium.get_data(), {'medium0': 'indian ink', 'over': 'pencil drawing', 'medium1': 'vellum', 'and': 'gold', 'color': 'light', 'coloron': 'white'})          
        
        #====================================================
        # Medium in Wikidata
        # e.g.: https://www.wikidata.org/wiki/Q12418
        # material used
        #               oil paint
        #               poplar wood
        #                 applies to part: painting surface
        #====================================================
        

if __name__ == '__main__':
    unittest.main()
    
    
