import mwparserfromhell
import re
#from tugbot import lookup_dicts


#===========================
#site_wikidata = pywikibot.Site("wikidata", "wikidata")
#repo_wikidata = site_wikidata.data_repository()

#site_commons  = pywikibot.Site("commons", "commons")
#===========================

def detect_langtags(work): # Detects tags of the form "{{de|Lampe}} {{en|lamp}} {{fr|lampe}}"
    matchObj = re.search( r'{{(..)\|(.*?)}}', work)
    if matchObj: return True
    return False
    
def split_langtags(work):
    language_fields = work.split("{{")
    lang_values_dict = {}
    for language_field in language_fields:
        #print ("language_field : ", language_field)
        matchObj = re.search( r'(..)\|(.*?)}}', language_field)
        if matchObj:
            lang_code = matchObj.group(1)
            value     = matchObj.group(2)
            #print ("     lang_code:", lang_code)
            #print ("     value    :", value)
            lang_values_dict [lang_code] = value
    return lang_values_dict

#===========================


class Free_text_parser:
        
    def __init__(self, wikicode):
        wikicode_parsed = mwparserfromhell.parse(wikicode)
        templates = wikicode_parsed.filter_templates()
    
        self.lang_and_text_dict   = {}
        
        if wikicode:
            # Manages "{{de|Lampe}} {{en|lamp}} {{fr|lampe}}"
            if detect_langtags(wikicode):
                self.lang_and_text_dict = split_langtags(wikicode)

            #TODO Manages "{{de}} Lampe {{en}} lamp {{fr}} lampe"
            
            elif "langswitch" in wikicode.lower():
            # Manages "{{Langswitch|de=Lampe|en=lamp|fr=lampe}}"
                for template in templates:
                    if template.name.matches("Langswitch"):
                        for i in template.params:
                            if i.split("="):
                                key   = i.split("=")[0].strip()
                                value = i.split("=")[1].strip()
                                if value and value != "":
                                    self.lang_and_text_dict[key] = value
            else:
                from langdetect import detect
                lang = detect(wikicode)
                self.lang_and_text_dict[lang] = wikicode
    
    def get_text(self, lang="en"):
        if lang in self.lang_and_text_dict:
            return self.lang_and_text_dict[lang]
        return None
    
    @property
    def languages(self):
        lang_list = [s for s in self.lang_and_text_dict.keys() ]
        return sorted(lang_list)
    
    def get_data(self):
        return self.lang_and_text_dict
    
            
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
