from tugbot import cat_def_parser
#from tugbot import lookup_dicts
import pywikibot
import re
site_commons = pywikibot.Site("commons", "commons")


#==========================================                                
def parse_museum(institution_text):
    institution_text = institution_text.replace("{{museum", "{{institution")
    institution_text = institution_text.replace("{{Museum", "{{institution")
    return parse_institution(institution_text)

def parse_institution(institution_text): 
    if ("{{institution:" in institution_text) or ("{{Institution:" in institution_text):
        institution_page_name = institution_text.replace("{{", "")
        institution_page_name = institution_page_name.replace("}}", "")
        institution_page_text = pywikibot.Page(site_commons, institution_page_name).text
        matchObj = re.search( r'[wW]ikidata *= *(Q\d+)', institution_page_text)
        institution_Q_number = ""
        if matchObj: 
            institution_Q_number = matchObj.group(1)
            return institution_Q_number 

#==========================================
class Institution_parser:
    def __init__(self, wikicode):
        if not wikicode: return None
        self.Q_number = None
        self.wikicode = wikicode
        self.wikicode = self.wikicode.replace("{{:", "{{")
        
        
        
        if re.search( r'[Mm]useum:', self.wikicode):
            self.Q_number = parse_museum( self.wikicode )
        elif re.search( r'[Ii]nstitution:', self.wikicode):
            self.Q_number = parse_institution( self.wikicode )
        else:
            institution_name = self.wikicode 
            institution_name = institution_name.replace("{{", "")
            institution_name = institution_name.replace("}}", "")
            institution_name = institution_name.split(":")[1]
            self.Q_number = cat_def_parser.get_q_number( institution_name )       
        
#---------------------               
    def get_data(self):
        return self.wikicode
    
    def get_q_number(self):
        return self.Q_number
    





        
