import mwparserfromhell
from tugbot import cat_def_parser
from tugbot import lookup_dicts


#==========================================                                
def parse_technique(size_text):
    fields = {}
    wikicode_parsed = mwparserfromhell.parse(size_text)
    templates = wikicode_parsed.filter_templates()
        
    for template in templates:
        if template.name.matches("technique"):
            medium_counter=0
            key   = None
            value = None
            for i in template.params:
                if ("=") in i:
                    key   = i.split("=", 1)[0].strip()
                    #if "and" in key:
                        #key = "medium"+str(medium_counter)
                        #medium_counter += 1
                    value = None
                    if (len(i.split("="))>1): value = i.split("=", 1)[1].strip()
                    if not value or value=="" : continue
                    fields[key] = value
                else:
                    key = "medium"+str(medium_counter)
                    medium_counter += 1
                    value = i
                fields[key] = value
    return fields

#==========================================
class Medium_parser:
    def __init__(self, wikicode):
        self.fields = {}
        if not wikicode: return None
    
        wikicode = wikicode.lower()
        
        if ("{{technique" in wikicode): self.fields = parse_technique( wikicode )
#---------------------               
    def get_data(self):
        return self.fields
    
    def get_q_numbers(self):
        q_number_table = []
        for i in self.fields:
            if self.fields[i] is None or self.fields[i] == "": 
                q_number_table.append( cat_def_parser.get_q_number(i, lookup_dict=_medium_Q_numbers) )
            else:
                q_number_table.append( cat_def_parser.get_q_number(self.fields[i], lookup_dict=lookup_dicts._medium_Q_numbers) )
        return q_number_table
    





        
