import re


#==========================================
class Reference_parser:
    def __init__(self, wikicode):
        self.reference = {}
        if not wikicode: return None
        self.wikicode = wikicode
    
        #wikicode = wikicode.lower()
        if (wikicode.startswith("[http")): self.reference["url"] = self.get_url() 
        if re.search( r'{{[Ll]ouvre[ _][Oo]nline', self.wikicode): self.reference["louvre_online"] = self.louvre_online
            
    # manages series of conventional links
    def get_url(self):
        link_dict = {}
        if "[http" in self.wikicode:
            link_list = self.wikicode.split("\n")
            for link in link_list:
                link = link.replace("[","")
                link = link.replace("]","")
                link_url   = link.split(" ")[0]
                link_title = link.replace(link_url,"")
                link_dict[link_url] = link_title.strip()
        if len(link_dict) == 0: return None
        return link_dict

    # for {{Louvre online|18059}}
    @property
    def louvre_online(self):
        louvre_online_search = re.search( r'{{[ *][Ll]ouvre[ _][Oo]nline[ *]|(\d*)}}', self.wikicode)
        if louvre_online_search:
            return louvre_online_search.group(1)
        
    def print_out(self):
        for i in self.reference :
            print("   ", i, "\t", self.reference[i])
            
    def __str__(self):
        work = ""
        for i in self.reference :
            work = work + "\n   "+i+"\t"+self.reference[i]
        return work
