#!/usr/bin/python3
#import re

import argparse
import pywikibot
import sys

from tugbot import cat_def_parser
from tugbot import date_parser
from tugbot import complex_date_parser


commons_site = pywikibot.Site("commons", "commons")

#=========================================
parser = argparse.ArgumentParser(description='Reads a Category from Commons described with the "Category definition: Object" template, creates a Wikidata item and attempts to fill information from the template into Wikidata')
parser.add_argument('cat_names', nargs = '*', help='names of the categories to process')
parser.add_argument('--commit', action="store_true", help='sends results to Wikidata. Default is not to send.')
args = parser.parse_args()
if not any(vars(parser.parse_args()).values()):
    parser.error('No arguments provided.')


commons_cats = args.cat_names

for commons_cat in commons_cats:
    if not ( commons_cat.startswith("Category:") or commons_cat.startswith("category:") ):
        commons_cat = "Category:"+commons_cat
    nice_commons_cat = commons_cat
    nice_commons_cat = nice_commons_cat.replace("Category:", "")
    nice_commons_cat = nice_commons_cat.replace("category:", "")
    nice_commons_cat = nice_commons_cat.replace("_", " ")
    print("commons_cat     :", commons_cat)
    print("nice_commons_cat:", nice_commons_cat)
    
    commons_page = pywikibot.Page(commons_site, commons_cat)
    commons_text = commons_page.text
    
    if not cat_def_parser.is_category_definition_object(commons_text): 
        sys.exit('The Wikimedia Commons page does not appear to have a "Category definition: Object" template')

    cat_definition = cat_def_parser.Cat_def_parser(commons_text)
    #print ( commons_text )
    #print (" ========= raw text above this line ============= ")
    #print ()
    
    
    
    
    ##TODO: detect templates for Louvre rooms, for instance
    ##TODO: detect museum catalogues such as Atlas etc, and fill in the relevant properties such as "Atlas ID" (P1212)
    
    print(cat_definition)
    
    labels_dict = {'en': nice_commons_cat}
    cat_definition.commit(labels_dict)


#pollute_wikidata = args.commit




#######################################
# Category:Geometry_problem-Sb_13088
# Category:Code_of_Hammurabi_(Louvre_Sb_8)
# Category:Louvre_AO_6501 
# Category:Bomber_sabre_of_the_Royal_Corps_of_the_Navy-MnM_2001.18.1
















 
